<?php
// OneThird CMS
// coyright(c) SpiQe Software,team1/3 All Rights Reserved.

	global $params;

	require_once(dirname(__FILE__).'/../config.php');
	require_once(dirname(__FILE__).'/../module/utility.basic.php');

	//options 
	//$params['staticout_path'] = "var/www/site";
	//$params['staticout_url'] = "http://www.site";
	//$params['staticout_enabled_module'] = ' .ex_folder.php .animate.php .smap.php .gmap.php .mod_prettify.php .highlighting_ace.php ';
	//$params['staticout_remove_path'] = "my_staticout_remove_path";
	//$params['staticout_conv_link'] = null;
	//$params['staticout_before_hook'] = "my_staticout_before_hook";
	//$params['staticout_after_hook'] = "my_staticout_after_hook";		//staticout_after_hook(&$buff, $path)
	//$params['staticout_force_ext'] = true;
	//$params['staticout_remote_addr'] = "127.0.0.1";
	

	basic_initialize();
	avoid_attack();
	snippet_avoid_robots();

	$params['manager'] = 'staticout';
	$params['template'] = 'admin.tpl';

	//エイリアスの逆引き設定	
	if (isset($params['circle']['meta']['alias'])) {
		foreach ($params['circle']['meta']['alias'] as $k=>$v) {
			if (is_array($v)) { continue; }
			$params['circle']['meta']['f_alias'][$v] = $k;
		}
	}

	// 標準プラグイン/テーマプラグイン読み込み
	load_site_plugin(false);

	if (!empty($params['staticout_remote_addr']) && $_SERVER["REMOTE_ADDR"] == $params['staticout_remote_addr'] 
		&& (
			isset($_GET['m']) && $_GET['m'] == 'remote_check_html'
			|| isset($_GET['m']) && $_GET['m'] == 'remote_write_html'
			)
		) {
		//リモートコマンド
	} else if (!check_rights('admin')) {
		exit_proc(403, 'Need administrator rights');
	}

	if (!isset($params['circle'])) {
		system_error( __FILE__, __LINE__ );
	}

	//パンくず表示
	$params['breadcrumb'][] = array( 'link'=>"{$_SERVER['REQUEST_URI']}", 'text'=>'write html' );

	$html['article'][] = draw_static();

	snippet_header();
	snippet_system_nav();
	snippet_footer();

	expand_circle_html();

function page_renderer2($p_page)
{
	global $p_circle,$config,$params,$database,$html,$params,$plugin_ar,$ut;

	$buff ='';

	$plugin_type = false;

	// ページ表示
	if ($p_page && $p_page != $params['circle']['meta']['top_page']) {
		//通常ページ
		read_pagedata($p_page, $params['page']);

	} else {
		//トップページ
		$params['top_page'] = true;
		if (!$plugin_type && !read_pagedata($params['circle']['meta']['top_page'], $params['page'])) {
			exit_proc(404, 'Top page not found');
			return;
		}
	}
	
	// ページ存在のチェック
	if (!$plugin_type && !isset($params['page'])) {
		return ;
	}
	
	// ページIDのセット
	if (!$plugin_type) {
		$plugin_type = $params['page']['type'];
		$p_page = $params['page']['id'];
		$p_link = $params['page']['link'];
		$block_type = $params['page']['block_type'];
	}

	// トップページテンプレートセット
	if (isset($params['top_page']) && isset($params['circle']['meta']['toppage_tpl']) && $params['circle']['meta']['toppage_tpl']) {
		$params['template'] = $params['circle']['meta']['toppage_tpl'].'.tpl';
	}

	// プラグインページ
	if ($plugin_type && isset($plugin_ar[$plugin_type])) {
		//プラグインページでは標準テンプレートを読み込む
		if (isset($params['page']['mode']) && $params['page']['mode'] == 0) {
			if (check_rights('edit')) {
				$html['information'][]='This page is currently being edited';
			} else {
				return;
			}
		}
		
		template_php($p_page);

		if (isset($params['rendering']) && !$params['rendering']) {
			return;
		}

		//プラグインページの表示
		$buff = get_plugin_page($plugin_type, $plugin_ar[$plugin_type], $params['page'], $params['page']['meta']);
		return $buff;

	}
	// パンくず設定
	if (isset($params['top_page'])) {
		$params['breadcrumb'][] = array( 'link'=>'', 'text'=>'HOME' );
	
	} else {
		if (!$params['page']['title']) {
			if (isset($plugin_ar[$plugin_type])) {
				$params['page']['title'] = $plugin_ar[$plugin_type]['title'];
			}
		}
		snippet_breadcrumb( $params['page']['link'], $params['page']['title'] );
	}
	
	$page_menu = '';
	
	// ページタイプチェック
	if (!isset($params['top_page'])) {
		if ($block_type == 5) {
			return;
		} else {
			if ($params['page']['mode'] == 0 || $block_type == 0) {
				return;
			}
		}
	}

	// ページ個別プラグインの読み込み
	template_php();	// ページ個別プラグインの読み込み
	if (isset($params['rendering']) && !$params['rendering']) {
		return ;
	}

	// 標準レンダラー呼び出し
	$buff .= basic_renderer($p_page, $page_menu);
	return $buff;
}

function draw_static()
{
	global $params,$config,$database,$p_circle,$html,$plugin_ar,$ut,$output_url,$staticout_base_path;
	
	snippet_overlay();
	
$html['css'][] = <<<EOT
	<style>
	.staticout-panel {
		background-color: #e6e6e6;
    	padding: 20px;
	}
	.staticout-buttons {
    	margin: 20px 0;
	}
	.staticout-panel p {
		line-height: 190%;
		padding: 0;
		margin:0;
	}
	.staticout {
		padding:20px;
		background-color: #fff4dd;
	}
	.staticout p {
		line-height: 100%;
		padding: 0;
		margin: 5px;
	}
	.staticout-alert {
		background-color: #efaeae;
		padding: 10px;
	}
	.staticout .item {
		position: relative;
		padding: 5px;
		display: inline-block;
		width: 200px;
		overflow: hidden;
		background-color: #EEE;
		border: 1px solid #b5b0b0;
		margin-left: 7px;
		height:30px;
	}
	.staticout .hnd {
		position: absolute;
		top:2px;
		right: 0;
		display: inline-block;
		color: #fff;
		padding: 0;
		margin: 0;
		line-height: 15px;
	}
	.staticout .hnd span {
		display: inline-block;
		width: 15px;
		height: 15px;
		margin-right:10px;
		border-radius: 19px;
		text-align: center;
		cursor:pointer;
	}
	.staticout .del {
		background-color: #f79a9a;
	}
	.staticout .add {
		background-color: #538e5c;
	}
	.staticout .allow {
		background-color: #efe9cf;
    }
	.staticout .deny {
		background-color: #fdbdaf;
	}
	.staticout .old {
		background-color: #9fb5ff;
	}
	.staticout .ref {
		background-color: #797979;
		font-size: 14px;
	}
	.staticout .dis {
		background-color: #bdbaba;
	}
	.staticout .pnl {
		cursor:pointer;
		text-shadow: 1px 1px 3px #ffffff;
		border: 2px solid #ffffff !important;
		box-shadow: 0px 0px 2px #3A3A3A;
		border-radius: 3px;
		width: 198px;
		text-align: center;
	}
	.staticout .allow .add{
		display:none;
	}
	.staticout .deny .del{
		display:none;
	}
	.staticout .deny .ref{
		display:none;
	}
	</style>
EOT;

	$buff = '';

	//初期化	
	$output_url = "{$params['circle']['files_url']}static";
	if (!empty($params['staticout_url'])) {
		$output_url = $params['staticout_url'];
	}
	$output_url = rtrim($output_url,'/').'/';

	$staticout_base_path = '';
	$mx = $ut->get_storage('staticout');
	if (isset($mx["staticout_base_path"])) {
		$staticout_base_path = sanitize_str($mx["staticout_base_path"]);
	}
	if (!$staticout_base_path) {
		$staticout_base_path = $output_url;
	}

	$output_path = $params['circle']['files_path'].DIRECTORY_SEPARATOR.'static';
	if (!empty($params['staticout_path'])) {
		$output_path = $params['staticout_path'];
	}
	$output_path = rtrim($output_path,"/\\".DIRECTORY_SEPARATOR);

	$staticout_allow_page_str = $staticout_allow_page = '';
	if (isset($mx["staticout_allow_page"])) {
		$staticout_allow_page_str = sanitize_str($mx["staticout_allow_page"]);
		$staticout_allow_page = explode(',',$staticout_allow_page_str);
	}
	$staticout_deny_page_str = $staticout_deny_page = '';
	if (isset($mx["staticout_deny_page"])) {
		$staticout_deny_page_str = sanitize_str($mx["staticout_deny_page"]);
		$staticout_deny_page = explode(',',$staticout_deny_page_str);
	}
	
	$staticout_enabled_module = ' .animate.php .smap.php .gmap.php .mod_prettify.php .highlighting_ace.php ';
	if (isset($params['staticout_enabled_module'])) {
		$staticout_enabled_module = $params['staticout_enabled_module'];
	}
	$staticout_conv_link = '';
	if (isset($params['staticout_conv_link'])) {
		if ($params['staticout_conv_link']) {
			$staticout_conv_link = $params['staticout_conv_link'];
		}
	}

	if ( isset($_GET['m']) && $_GET['m'] == 'remote_check_html' )  {
		$top = $params['circle']['meta']['top_page'];
		$r = array();
		
		$path = $output_path;
		if (!is_dir($path)) {
			$r['result'] = false;
			echo( json_encode($r) );
			exit();
		}

		$sql = array();
		$sql[0] = "select id from ".DBX."data_items";
		$sql[1] = array(" where type<>? and block_type <> 5 and mode<>0 and mode <>10 and block_type <= 10", HIDDEN_ID);
		$sql[2] = array(" order by mod_date desc");
		$ar = $database->sql_select_all($sql);
		$body = '';
		foreach ($ar as $v) {
			$body .= "w:{$v['id']}\n";
		}
		$r['file'] = $output_path.DIRECTORY_SEPARATOR."url_list.log";
		$r['count'] = count($ar);
		$r['result'] = file_put_contents($r['file'],$body);
		echo( json_encode($r) );
		exit();
	}
	
	if ( isset($_GET['m']) && $_GET['m'] == 'remote_write_html' )  {
		$top = $params['circle']['meta']['top_page'];
		$r = array();

		$file = $r['file'] = $output_path.DIRECTORY_SEPARATOR."url_list.log";
		$ar = file_get_contents($r['file']);
		
		$ar = explode("\n",$ar);
		
		$body = '';
		$id = false;
		$remain = 0;
		foreach ($ar as $v) {
			if (!$v) { continue; }
			if (!$id && substr($v,0,2) == 'w:') {
				$id = substr($v,2);
			} else if (substr($v,0,2) == 'w:') {
				++$remain;
				$body .= $v."\n";
			} else {
				$body .= $v."\n";
			}
		}
		if (!$id) {
			exit();
		}
		$r['result'] = false;
		$r['id'] = $id;
		$r['output_path'] = $output_path;
		$r['staticout_allow_page'] = $staticout_allow_page;
		$r['staticout_deny_page'] = $staticout_deny_page;
		$mx = $ut->get_storage('staticout');
		$mx["staticout_base_path"] = $staticout_base_path;

		$r['staticout_conv_link'] = $staticout_conv_link ;
		$r['staticout_enabled_module'] = $staticout_enabled_module;

		staticout_one_page($r['id'], $r, $output_path, $output_url);
		if (!empty($r['skip_page'])) {
			$body .= "*:{$id}\n";
		} else if (!empty($r['progress_mess'])) {
			$body .= " :{$id}\n";
		}
		$r['result'] = file_put_contents($file,$body);
		$r2 = array();
		$r2['remain'] = $remain;
		$r2['id'] = $id;
		echo( json_encode($r2) );
		exit();
	}

$buff.= <<<EOT
	<h1>Static HTML Output Tool v1.73a</h1>
EOT;
$panel = <<<EOT
	<div class='staticout-panel'>
		<div class='staticout-buttons'>
			<a href='javascript:void(check_html())' class='onethird-button '  >Check html</a>
			<a href='javascript:void(write_html())' class='onethird-button '  >Write html</a>
			<a href='javascript:void(scan_html())' class='onethird-button '  >Scan html</a>
			<a href='javascript:void(write_files())' class='onethird-button '  >Write other files</a>
			<a href='javascript:void(remove_files())' class='onethird-button mini ' >Remove html files</a>
EOT;
			if (empty($params['staticout_path'])) {
$panel.= <<<EOT
				<a href='javascript:void(remove_dir())' class='onethird-button mini ' >remove static dir</a>
EOT;
				if (is_file($output_path.DIRECTORY_SEPARATOR."static.zip")) {
$panel.= <<<EOT
					<a href='{$output_url}/static.zip' class='onethird-button mini ' >download zip</a>
EOT;
				} else {
$panel.= <<<EOT
					<a href='javascript:void(make_static_zip())' class='onethird-button mini ' >Create download zip</a>
EOT;
				}
			}
$panel.= <<<EOT
		</div>
		<p>
			<span style='width:10em;display:inline-block'>Base path</span> <input type='text' value='{$staticout_base_path}' id='staticout_base_path' style='min-width:500px' />
		</p>
		<p>
			<span style='width:10em;display:inline-block'>Allow page</span> <input type='text' value='{$staticout_allow_page_str}' id='staticout_allow_page' style='min-width:500px' />
		</p>
		<p>
			<span style='width:10em;display:inline-block'>Deny page</span> <input type='text' value='{$staticout_deny_page_str}' id='staticout_deny_page' style='min-width:500px' />
		</p>
		<p>
			<span style='width:10em;display:inline-block'>Output path</span> $output_path
		</p>
		<p>
			<span style='width:10em;display:inline-block'>Output url</span> <a href='$output_url' target='_blank'>$output_url</a>
		</p>
		<p>
			<span style='width:10em;display:inline-block'>enabled module</span>
			$staticout_enabled_module
		</p>
		<p>
			<span style='width:10em;display:inline-block'>replace html</span>
			before : {$ut->check(!empty($params['staticout_before_hook']),'custom','none')}, after : {$ut->check(!isset($params['staticout_after_hook']),'standard','custom')}
		</p>
		<p>
			<span style='width:10em;display:inline-block'>conv link</span>
			{$ut->check($staticout_conv_link=='my_ut_link','standard',$ut->check($staticout_conv_link,'custom','none'))}
		</p>
		<p>
			<span style='width:10em;display:inline-block'>replace other files</span>
			{$ut->check(!empty($params['staticout_remove_path']),'custom','none')}
		</p>
		<p>
			<span style='width:10em;display:inline-block'>force ext</span>
			{$ut->check(isset($params['staticout_force_ext']),'YES','OFF')}
		</p>
		
	</div>
EOT;

	$buff .= $panel;

$html['meta'][] = <<<EOT
	<script>
	function check_html(page_offset) {
		var u = "ajax=check_html";
		u += "&staticout_base_path="+encodeURIComponent(\$('#staticout_base_path').val());
		u += "&staticout_allow_page="+encodeURIComponent(\$('#staticout_allow_page').val());
		u += "&staticout_deny_page="+encodeURIComponent(\$('#staticout_deny_page').val());
		if (page_offset) {
			u += "&offset="+page_offset;
		}
		u += "&check=1";
		\$('#id_staticout').html('');
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: u
			, dataType:'json'
			, success: function(data){
				if (data && data['result']) {
					if (data['pagination']) {
						\$('#id_staticout').append(data['pagination']);
					}
					\$('#staticout_base_path').val(data['staticout_base_path']);
					\$('#id_staticout').append("<div>Count : "+data['total_c']+"</div>");
					\$('#id_staticout').append("<div><span class='item allow pnl' onclick=\"show_item('allow')\">allow output </span><span class='item deny pnl' onclick=\"show_item('deny')\">deny output </span><span class='item old pnl' onclick=\"show_item('old')\">old file </span><span class='item dis pnl' onclick=\"show_item('dis')\">none </span></div>");
					for (var i=0; i < data['check'].length;++i) {
						var x = data['check'][i];
						var y = '';
						if (x[1]) {
							y = "<span id ='item"+x[0]+"' class='item allow";
							if (x[1] && !x[3]) {
								y += " dis ";
							}
							if (x[5]) {
								y += " old ";
							}
						} else {
							y = "<span id ='item"+x[0]+"' class='item deny";
						}
						
						y += "' data-idx='"+x[0]+"' > ";
						var t = '';
						if (!x[4]) {
							t += "#"+x[0];
						} else {
							if (x[4].substr(-5)=='.html' && x[4].substr(0,1)=='p') {
								t += x[4].substr(0,x[4].length-5);
							} else {
								t += x[4];
							}
						}
						y += " <a href='javascript:void(openurl("+x[0]+",1))'>"+t+"</a>";
						if (!x[2]) {
							x[2] = "---";
						}
						y += " / <a href='javascript:void(openurl("+x[0]+",0))'>"+x[2]+"</a>";
						y += "<span class='hnd'>";
						y += "<span class='ref' onclick='output_one("+x[0]+")'>R</span>";
						y += "<span class='add' onclick='chg_outputmode("+x[0]+",1)'>+</span>";
						y += "<span class='del' onclick='chg_outputmode("+x[0]+",0)'>-</span>";
						y += "</span></span>";
						\$('#id_staticout').append(y);
					}
				} else {
					if (data['mess']) {
						alert(data['mess']);
					} else {
						alert('failed');
					}
				}
			}
			, error: function(data){
				alert('failed');
			}
		});
	}
	function show_item(m) {
		\$('.item[data-idx]').hide();
		\$('.'+m+'[data-idx]').show();
	}
	function write_html() {
		var id = \$('#id_staticout .allow.dis:first').attr('data-idx');
		if (!id) {
			id = \$('#id_staticout .allow.old:first').attr('data-idx');
		}
		if (id) {
			ot.ajax({
				type: "POST"
				, url: '{$_SERVER['REQUEST_URI']}'
				, data: "ajax=output_one&id="+id
				, dataType:'json'
				, idx:id
				, success: function(data){
					if (data && data['result']) {
						\$("#id_staticout #item"+this.idx).removeClass('old').removeClass('dis');
						write_html();
					}
				}
			});
		}
	}
	function output_one(id) {
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=output_one&id="+id
			, dataType:'json'
			, idx:id
			, success: function(data){
				if (data && data['result']) {
					\$("#id_staticout #item"+this.idx).removeClass('old').removeClass('dis');
				}
			}
		});
	}
	function move_page(page) {
		check_html(page);
	}
	function chg_outputmode(id,mode,force) {
		if (mode==0) {
			var u = "ajax=remove_hfile&id="+id;
			ot.ajax({
				type: "POST"
				, url: '{$_SERVER['REQUEST_URI']}'
				, data: u
				, dataType:'json'
				, success: function(data){
					if (data && data['result']) {
						ot.ajax({
							type: "POST"
							, url: '{$_SERVER['REQUEST_URI']}'
							, data: "ajax=chg_outputmode&id="+data.id+"&m=0"
							, dataType:'json'
							, success: function(data){
								if (data && data['result']) {
									\$("#staticout_allow_page").val(data.allow);
									\$("#staticout_deny_page").val(data.deny);
									\$("#id_staticout #item"+data['id']).removeClass('allow').addClass('deny');
								}
							}
						});
					} else {
						alert('error');
					}
				}
			});
		} else {
			var u = "ajax=chg_outputmode&id="+id+"&m=1";
			if (force) {
				u += "&force=1";
			}
			ot.ajax({
				type: "POST"
				, url: '{$_SERVER['REQUEST_URI']}'
				, data: u
				, dataType:'json'
				, success: function(data){
					if (data && data['result']) {
						\$("#staticout_allow_page").val(data.allow);
						\$("#staticout_deny_page").val(data.deny);
						\$("#id_staticout #item"+data['id']).removeClass('deny').addClass('allow');
						\$("#id_staticout #item"+data['id']).removeClass('dis');
					}  else {
						if (data.skip_page && data.result_str) {
							if (confirm("Error : "+data.result_str+"\\n Do you wants add allow option?")) {
								chg_outputmode(data.id,data.mode,1);
							}
						}
					}
				}
			});
		}
	}
	function scan_html(id) {
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=scan_html"
			, dataType:'json'
			, success: function(data){
				if (data && data['result']) {
					\$("#id_staticout" ).html(data['html']);
				}
			}
		});
	}
	function remove_hfile(file,obj) {
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=remove_hfile&file="+decodeURIComponent(file)
			, dataType:'json'
			, obj:obj
			, success: function(data){
				if (data && data['result']) {
					\$(this.obj).parents('.item').fadeOut();
				}
			}
		});
	}
	
	function openurl(id,mode) {
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=openurl&id="+id+"&mode="+mode
			, dataType:'json'
			, async: false
			, success: function(data){
				if (data && data['url']) {
					window.open(data['url'],'_blank');
				}
			}
		});
	}
	
	function write_files() {
		ot.overlay(1, "<div style='background:#fff;padding:20px;'><img src='{$config['site_url']}img/loading.gif' /></div>")
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=write_files"
			, dataType:'json'
			, success: function(data){
				ot.overlay(0);
				if (data && data['result']) {
					alert('done');
					location.reload(true);
				} else {
					if (data['mess']) {
						alert(data['mess']);
					} else {
						alert('failed');
					}
				}
			}
		});
	}
	function remove_files() {
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=remove_files"
			, dataType:'json'
			, success: function(data){
				if (data && data['result']) {
					alert('done');
					//location.reload(true);
				} else {
					if (data['mess']) {
						alert(data['mess']);
					} else {
						alert('failed');
					}
				}
			}
		});
	}
	function remove_dir() {
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=remove_dir"
			, dataType:'json'
			, success: function(data){
				if (data && data['result']) {
					alert('done');
					//location.reload(true);
				} else {
					if (data['mess']) {
						alert(data['mess']);
					} else {
						alert('failed');
					}
				}
			}
		});
	}
	function make_static_zip() {
		ot.overlay(1, "<div style='background:#fff;padding:20px;'><img src='{$config['site_url']}img/loading.gif' /><p>making...</p></div>")
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=make_static_zip"
			, dataType:'json'
			, success: function(data){
				if (data && data['result']) {
					ot.overlay(0);
					location.href="{$output_url}/static.zip";
				} else {
					if (data['mess']) {
						alert(data['mess']);
					} else {
						alert('failed');
					}
				}
			}
		});
	}
	</script>
EOT;

	if (isset($_GET['id'])) {
		$r = array();
		$r['result'] = false;
		$r['id'] = (int)($_GET['id']);
		$r['output_path'] = $output_path;
		$r['staticout_allow_page'] = $staticout_allow_page;
		$r['staticout_deny_page'] = $staticout_deny_page;

		$mx = $ut->get_storage('staticout');
		$mx["staticout_base_path"] = $staticout_base_path;
		$ut->set_storage('staticout',$mx);

		$r['staticout_conv_link'] = $staticout_conv_link ;
		$r['staticout_enabled_module'] = $staticout_enabled_module;
		if (staticout_one_page($r['id'], $r, $output_path, $output_url, true)) {
			$c = 'allow';
			$d = $ut->check(!empty($r['file_old']),' old ');
			$e = $ut->check(empty($r['is_file']),' dis ');
		} else {
			$c = 'deny';
			$e = $d = '';
		}
$buff.= <<<EOT
		<div class='staticout' id ='id_staticout' >
			<span id ='item{$r['id']}' class="item $c $d $e" data-idx='{$r['id']}' >
				<a href='javascript:void(openurl({$r['id']},0))'>
					{$ut->str(empty($r['file'])?"#".$r['id']:$r['file'])}
				</a>
					{$ut->str(adjust_mstring($params['page']['title']))}
				<span class='hnd'>
				<span class='ref' onclick='output_one({$r['id']})'>R</span>
				<span class='add' onclick='chg_outputmode({$r['id']},1)'>+</span>
				<span class='del' onclick='chg_outputmode({$r['id']},0)'>-</span>
				</span>
			</span>
		</div>
EOT;
	} else {
$buff.= <<<EOT
		<div class='staticout' id ='id_staticout' >
		</div>
EOT;
$html['meta'][] = <<<EOT
		<script>
			check_html();
		</script>
EOT;
	}

	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'scan_html' )  {
		$r = array();
		$r['result'] = false;
		if (is_dir($output_path)) {
			$r['result'] = true;
			if (empty($params['staticout_force_ext'])) {
				$x = scandir($output_path);
				$ar = array();
				foreach ($x as &$v) {
					if ($v=='.' || $v== '..') { continue; }
					$f = $output_path.DIRECTORY_SEPARATOR.$v;
					if (is_file($f)) {
						$path_parts = pathinfo($f);
						if (empty($path_parts['extension']) || $path_parts['extension'] == 'html') {
							$ar[] = array('f'=>$v, 't'=>filemtime($f));
						}
					}
				}
				unset($v);
				unset($x);
				function _tmpsort($arg1, $arg2) {
					if ($arg1['t'] == $arg2['t']) { return 0; }
					return ($arg1['t'] < $arg2['t']) ? 1 : -1;
				}
				usort($ar, '_tmpsort');
			} else {
				$ar = @glob($output_path.DIRECTORY_SEPARATOR.'*.html');
			}
		} else {
			$ar = false;
		}
		$buff = '';
		if ($ar) {
			$c = count($ar);
$buff.= <<<EOT
			<p>
				$c pages
			</p>
EOT;
			foreach ($ar as $v) {
				$buff .= "<span class='item allow'><a href='{$output_url}{$v['f']}' target='_blank'>{$v['f']}</a> <span class='hnd'><span class='del' onclick='remove_hfile(\"{$v['f']}\",this)'>-</span></span></span> ";
			}
		}
		$r['html'] = $buff;
		echo( json_encode($r) );
		exit();
	}

	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'chg_outputmode' )  {
		$r = array();
		$r['result'] = false;
		$r['id'] = (int)($_POST['id']);
		$r['mode'] = (int)($_POST['m']);
		$force = isset($_POST['force']);
		$allow = $deny = '';
		if (is_array($staticout_allow_page)) {
			$allow = implode(',',$staticout_allow_page);
		}
		if (is_array($staticout_deny_page)) {
			$deny = implode(',',$staticout_deny_page);
		}
		
		$allow = ','.trim($allow,',').',';
		$deny = ','.trim($deny,',').',';
		if ($r['mode'] == 1) {
			$tmp = str_replace(",{$r['id']},","",$deny);
			if ($tmp != $deny) {
				$deny = $tmp;
			} else {
				$allow = $r['id'].",".$allow;
			}
		} else if ($r['mode'] == 0) {
			$tmp = str_replace(",{$r['id']},","",$allow);
			if ($tmp != $allow) {
				$allow = $tmp;
			} else {
				$deny = $r['id'].",".$deny;
			}
		} else {
			echo( json_encode($r) );
			exit();
		}
		$allow = str_replace(",,",",",$allow);
		$deny = str_replace(",,",",",$deny);
		$allow = trim($allow,',');
		$deny = trim($deny,',');

		$r['result'] = true;
		if ($r['mode'] == 1) {
			$r['output_path'] = $output_path;
			$r['staticout_allow_page'] = $staticout_allow_page;
			$r['staticout_deny_page'] = $staticout_deny_page;

			$mx = $ut->get_storage('staticout');
			$mx["staticout_base_path"] = $staticout_base_path;
			$ut->set_storage('staticout',$mx);

			$r['staticout_conv_link'] = $staticout_conv_link ;
			$r['staticout_enabled_module'] = $staticout_enabled_module;

			staticout_one_page($r['id'], $r, $output_path, $output_url);
			if (!empty($r['skip_page'])) {
				if ($force) {
					$r['staticout_allow_page'][] = $r['id'];
					$r['result'] = true;
					staticout_one_page($r['id'], $r, $output_path, $output_url);
					if (!empty($r['skip_page'])) {
						$r['result'] = false;
					}
				} else {
					$r['result'] = false;
				}
			}
		}
		if ($r['result']) {
			$mx = $ut->get_storage('staticout');
			$mx["staticout_allow_page"] = $allow;
			$mx["staticout_deny_page"] = $deny;
			$ut->set_storage('staticout',$mx);
		}
		$r['allow'] = $allow;
		$r['deny'] = $deny;
		echo( json_encode($r) );
		exit();
	}

	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'output_one' )  {
		$r = array();
		$r['result'] = false;
		$r['id'] = (int)($_POST['id']);
		$r['output_path'] = $output_path;
		$r['staticout_allow_page'] = $staticout_allow_page;
		$r['staticout_deny_page'] = $staticout_deny_page;
		$mx = $ut->get_storage('staticout');
		$mx["staticout_base_path"] = $staticout_base_path;
		$ut->set_storage('staticout',$mx);

		$r['staticout_conv_link'] = $staticout_conv_link ;
		$r['staticout_enabled_module'] = $staticout_enabled_module;

		staticout_one_page($r['id'], $r, $output_path, $output_url);
		if (!empty($r['skip_page'])) {
		} else if (!empty($r['progress_mess'])) {
			$r['result'] = true;
		}
		echo( json_encode($r) );
		exit();
	}

	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'check_html' )  {
		$top = $params['circle']['meta']['top_page'];
		$r = array();
		$r['result'] = true;
		$continue = true;
		$r['count'] = 0;
		$r['file'] = 'progress';
		$r['top'] = $top;
		$r['staticout_base_path'] = sanitize_str($_POST['staticout_base_path']);
		if ($r['staticout_base_path']) {
			$staticout_base_path =$r['staticout_base_path'];
		} else {
			$r['staticout_base_path'] = $staticout_base_path;
		}
		$r['staticout_conv_link'] = $staticout_conv_link ;
		$r['staticout_allow_page'] = sanitize_str($_POST['staticout_allow_page']);
		$r['staticout_allow_page'] = explode(',',$r['staticout_allow_page']);
		$r['staticout_deny_page'] = sanitize_str($_POST['staticout_deny_page']);
		$r['staticout_deny_page'] = explode(',',$r['staticout_deny_page']);
		
		$r['progress_mess'] = '';
		$r['update'] = (isset($_POST['update'])) ? true: false;

		$mx = $ut->get_storage('staticout');
		$mx["staticout_base_path"] = $staticout_base_path;
		if (is_array($r['staticout_allow_page'])) {
			$mx["staticout_allow_page"] = implode(',',$r['staticout_allow_page']);
		} else {
			$mx["staticout_allow_page"] = array();
		}
		if (is_array($r['staticout_deny_page'])) {
			$mx["staticout_deny_page"] = implode(',',$r['staticout_deny_page']);
		} else {
			$mx["staticout_deny_page"] = array();
		}
		$ut->set_storage('staticout',$mx);

		$path = $output_path;
		if (!is_dir($path)) {
			if (!@mkdir($path, $config['permission'])) {
				$r['result'] = false;
				echo( json_encode($r) );
				exit();
			}
		}

		//先に圧縮ファイルを削除しておく
		$out = $output_path.DIRECTORY_SEPARATOR."static.zip";
		$r['out'] = $out;
		if (is_file($out)) {
			unlink($out);
		}

		$sql = array();
		$sql[0] = "select count(id) as c from ".DBX."data_items";
		$sql[1] = array(" where type<>? and block_type <> 5 and mode<>0 and mode <>10 and block_type <= 10", HIDDEN_ID);
		$ar = $database->sql_select_all($sql);
		if ($ar) {
			$r['total_c'] = $total_c = $ar[0]['c'];
		}
		$offset = 0;
		$page_size = 500;
		if (isset($_POST['offset'])) {
			$offset = (int)$_POST['offset'];
		}
		$option = array('total'=>$total_c, 'offset'=>$offset, 'page_size'=>$page_size, 'url_script'=>"move_page");
		$r['pagination'] = std_pagination_renderer($option);

		//下層ページの配列を作成
		$staticout = array();
		$sql[0] = "select id,type from ".DBX."data_items";
		$sql[2] = array(" order by mod_date desc  {$ut->limit($offset*$page_size,$page_size)}");
		$ar = $database->sql_select_all($sql);
		foreach ($ar as $v) {
			$staticout[] = $v['id'];
		}
		$r['result'] = 'true';
		$r['staticout_enabled_module'] = $staticout_enabled_module;
		if (!empty($staticout)) {
			$r['count'] = count($staticout);
			$r['check'] = array();
			foreach ($staticout as $v) {
				if (staticout_one_page($v, $r, $output_path, $output_url, true)) {
					$r['check'][] = array($v,true,adjust_mstring($params['page']['title'],20),$r['is_file'],$r['file'],!empty($r['file_old']));
				} else {
					$r['check'][] = array($v,false,adjust_mstring($params['page']['title'],20));
				}
			}
		}
		echo( json_encode($r) );
		exit();
	}

	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'write_files' )  {
		$r = array();
		$r['result'] = true;
		$path = $output_path;
		if (!is_dir($path)) {
			if (!@mkdir($path, $config['permission'])) {
				$r['result'] = false;
				echo( json_encode($r) );
				exit();
			}
		}

		// テンプレートファイルのコピー
		// 素材等、OneThird管理外のファイルのコピー
		$path0 = $params['circle']['files_path'].DIRECTORY_SEPARATOR.'data';
		$path1 = $output_path;
		scan_dir10($path0, $ar);
		$path0_len = strlen($path0);
		foreach ($ar as $v) {
			$path_parts = pathinfo($v);
			if (empty($path_parts['extension'])) { continue; }
			$ext = strtolower($path_parts['extension']);
			$dst = $path1.substr($v,$path0_len);
			if (!is_dir(dirname($dst))) {
				mkdir(dirname($dst), $config['permission'], true);
			}
			if (!is_file($dst)) {
				if ($ext == 'php' || $ext == 'less' || $ext == 'tpl') {
				} else if ($ext == 'css') {
					copy($v, $dst);
					$b = @file_get_contents($dst);
					if ($b) {
						if (@file_put_contents($dst, staticout_remove_path($b))) {
						}
					}
				} else {
					copy($v, $dst);
				}
			}
		}

		//onethird systemファイルのコピー
		$path0 = $config['site_path'].DIRECTORY_SEPARATOR.'css';
		$path1 = $output_path.DIRECTORY_SEPARATOR.'css';
		copy_dir10($path0, $path1);

		$path0 = $config['site_path'].DIRECTORY_SEPARATOR.'img';
		$path1 = $output_path.DIRECTORY_SEPARATOR.'img';
		copy_dir10($path0, $path1);

		//イメージファイルのコピー
		$files = substr($config['files_path'],strlen($config['site_path'])).DIRECTORY_SEPARATOR;
		$path0 = $config['files_path'].DIRECTORY_SEPARATOR.'img';
		$path1 = $output_path.$files.'img';
		copy_dir10($path0, $path1);
	
		echo( json_encode($r) );
		exit();
	}

	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'openurl' )  {
		$r = array();

		$r['id'] = $id = (int)$_POST['id'];
		$r['mode'] = (int)$_POST['mode'];
		if ($r['mode'] == 1) {
			$r['url'] = $ut->link($id);
			echo( json_encode($r) );
			exit();
		}
		//file name取得
		$f = $config['permalink'];
		if (isset($params['circle']['meta']['f_alias'][$id])) {
			$f = $params['circle']['meta']['f_alias'][$id];
		} else {
			$f = str_replace('{page}', $id, $f);
		}
		$path_parts = pathinfo($f);
		if ($id == $params['circle']['meta']['top_page']) {
			$f = 'index.html';
		} else {
			$f = $path_parts['filename'];
		}
		$file = $output_path.DIRECTORY_SEPARATOR.$f;
		$r['file'] = $file;
		$r['f'] = $f;
		$r['output_url'] = $output_url;
		if (is_file($file)) {
			$r['url'] = rtrim($output_url,'/').'/'.$f;
		} else if (is_file($file.'.html')) {
			$r['url'] = $output_url.$f.'.html';
		} else {
			$r['url'] = $ut->link($id);
		}
		echo( json_encode($r) );
		exit();
	}

	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'remove_hfile' )  {
		$r = array();
		$r['result'] = false;
		if (isset($_POST['file'])) {
			$f = $output_path.DIRECTORY_SEPARATOR.sanitize_str($_POST['file']);
			if (is_file($f)) {
				$r['result'] = @unlink($f);
			}
		} else if (isset($_POST['id'])) {
			$r['id'] = $id = (int)$_POST['id'];
			//file name取得
			$f = staticout_get_filename($id);
			$file = $output_path.DIRECTORY_SEPARATOR.$f;
			$r['file'] = $file;
			$r['result'] = true;
			if (is_file($file)) {
				$r['result'] = @unlink($file);
			}
		}
		echo( json_encode($r) );
		exit();
	}

	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'remove_files' )  {
		$r = array();
		$r['result'] = true;

		$path = $output_path;
		//remove_directory($output_path);
		$ar = @glob($output_path.DIRECTORY_SEPARATOR.'*.html');
		foreach ($ar as $v) {
			$r['del7'][] = $v;
			unlink($v);
		}
		foreach ($params['circle']['meta']['alias'] as $k=>$v) {
			$v = $output_path.DIRECTORY_SEPARATOR.$k;
			if (is_file($v)) {
				$r['del8'][] = $v;
				unlink($v);
			}
		}

		echo( json_encode($r) );
		exit();
	}
	
	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'remove_dir' )  {
		$r = array();
		$r['result'] = true;
		$output_path = $params['circle']['files_path'].DIRECTORY_SEPARATOR.'static';
		remove_directory($output_path);
		echo( json_encode($r) );
		exit();
	}
	

	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'make_static_zip' )  {
		$r = array();
		$r['result'] = true;

		//先に圧縮ファイルを削除しておく
		$out = $output_path.DIRECTORY_SEPARATOR."static.zip";
		$vv = array();
		scan_dir10($output_path,$ar);
		foreach ($ar as $v) {
			$vv[] = substr($v,strlen($output_path)+1);
		}
		$r['vv'] = $vv;
		$zip = new ZipArchive();
		if ($zip->open($out, ZipArchive::CREATE) === true) {
			foreach($vv as $v) {
				$f = $output_path.DIRECTORY_SEPARATOR.$v;
				if (is_file($f)) {
					$r['v'][] = $f;
					$zip->addFile($f, 'static'.DIRECTORY_SEPARATOR.$v);
				}
			}
			$zip->close();
		} else {
			$r['mess'] = 'ZIP-error';
		}
		
		echo( json_encode($r) );
		exit();
	}

	return frame_renderer($buff);
}

function staticout_one_page($id, &$r, $output_path, $output_url, $check=false)
{
	global $params,$config,$ut,$p_circle, $html, $staticout_base_path;
	
	$params['static_outmode'] = true;
	$staticout_enabled_module = $r['staticout_enabled_module'];
	
	$r['id'] = $id;
	$params['page'] = array();
	if (read_pagedata($id, $params['page'])) {
		if ($params['page']['type'] == HIDDEN_ID || $params['page']['mode'] == 0 || $params['page']['mode'] == 10 || (int)$params['page']['block_type'] >= 10) {
			$r['skip_page'] = "<p><a href='{$ut->link($id)}'>hidden($id) : {$params['page']['title']}</a></p>";
			$r['result_str'] = "hidden page";
			return false;
		}
		$ok = true;
		if (isset($params['page']['meta']['template_ar']['php'])) {
			if (is_array($params['page']['meta']['template_ar']['php'])) {
				foreach ($params['page']['meta']['template_ar']['php'] as $vv) {
					if (strstr($staticout_enabled_module, $vv) === false) {
						$ok = false;
						$r['skip_page'] = "<p><a href='{$ut->link($id)}'>reject module {$id} : {$params['page']['title']}</a></p>";
						$r['result_str'] = "reject module";
						$params['page']['title'] = ' '.$params['page']['title'];
						break;
					}
				}
			} else {
				$vv = $params['page']['meta']['template_ar']['php'];
				if (strstr($staticout_enabled_module, $vv) === false) {
					$ok = false;
					$r['skip_page'] = "<p><a href='{$ut->link($id)}'>reject module #{$id} : {$params['page']['title']}</a></p>";
					$r['result_str'] = "reject module";
					$params['page']['title'] = ' '.$params['page']['title'];
				}
			}
		}
		if ($ok && strstr($params['page']['contents'],"{\$plugin") !== false) {
			$ok = false;
			$r['skip_page'] = "<p><a href='{$ut->link($id)}'>reject plugin #{$id} : {$params['page']['title']}</a></p>";
			$r['result_str'] = "reject plugin";
			$params['page']['title'] = '_'.$params['page']['title'];
		}
		if ($ok && isset($params['page']['meta']['renderer']) && count($params['page']['meta']['renderer'])>1) {
			$ok = false;
			$r['skip_page'] = "<p><a href='{$ut->link($id)}'>reject renderer #{$id} : {$params['page']['title']}</a></p>";
			$r['result_str'] = "reject renderer";
			$params['page']['title'] = '*'.$params['page']['title'];
		}
		if (!empty($r['staticout_allow_page'])) {
			if (array_search($id, $r['staticout_allow_page'])!==false) {
				$ok = true;
				unset($r['skip_page']);
			}
		}
		if (!empty($r['staticout_deny_page'])) {
			if (array_search($id, $r['staticout_deny_page'])!==false) {
				$ok = false;
				$r['skip_page'] = "<p><a href='{$ut->link($id)}'>deny #{$id} : {$params['page']['title']}</a></p>";
				$r['result_str'] = "deny";
			}
		}
		if (!$ok) {
			return false;
		}
	} else {
		$r['skip_page'] = "<p>Page not found #{$id}</p>";
		$r['result_str'] = "Page not found";
		return  false;
	}

	//file name取得
	$f = staticout_get_filename($id);
	if ($check) {
		$r['file'] = $f;
		$r['is_file'] = is_file($output_path.DIRECTORY_SEPARATOR.$f);
		$r['file_old'] = false;
		if ($r['is_file']) {
			if (filemtime($output_path.DIRECTORY_SEPARATOR.$f) < strtotime($params['page']['mod_date'])) {
				$r['file_old'] = true;
			}
		}
		return true;
	}

	//パラメータ調整
	$params['circle']['meta']['hide_login'] = true;
	$params['circle']['meta']['hide_nav'] = true;
	unset($params['page-owner']);
	unset($params['manager']);

	//パラメータ設定
	$html = array();
	unset($params['template']);

	//一時的にログイン状態を解除
	$login_id_back = $_SESSION['login_id'];
	unset($_SESSION['login_id']);

	$data_url = $params['data_url'];
	$circle_url = $params['circle']['url'];
	$site_url = $config['site_url'];
	$join_flag = $params['circle']['join_flag'];
	$breadcrumb = $params['breadcrumb'];
	
	$params['data_url'] = "";
	$config['site_url'] = $staticout_base_path;
	$params['circle']['url'] = $staticout_base_path;
	$params['circle']['join_flag'] = 1;
	unset($params['breadcrumb']);

	if ($r['staticout_conv_link']) {
		$params['hook']['ut_link'][] = $r['staticout_conv_link'];
	}

	//page_renderer2を使い下層ページ作成
	$x = array();
	$r['id'] = $x[0] = $id;
	$html = array();
	$buff = '';

	try {
		$buff = page_renderer2($id);
		if ($buff) {
			$html['article'][] = $buff;
		}
	} catch (PDOException $e) {
	}

	snippet_header();
	snippet_footer();
	$html['meta']['loginform'] = ' ';
	$html['meta']['dialog'] = '';

	if (!empty($html['article']) && count($html['article']) && empty($params['static_outmode_stop'])) {

		staticout_before_hook();
		$buff = expand_circle_html($params['page']['meta'], true);

		$params['data_url'] = $data_url;
		$params['circle']['url'] = $circle_url;
		$config['site_url'] = $site_url;
		$params['circle']['join_flag'] = $join_flag;
		$_SESSION['login_id'] = $login_id_back;
		$params['breadcrumb'] = $breadcrumb;

		staticout_after_hook($buff, $staticout_base_path);
		if (isset($params['hook']['staticout']) && is_array($params['hook']['staticout'])) {
			foreach ($params['hook']['staticout'] as $v) {
				if (function_exists($v)) {
					$v($id,$buff);
				}
			}
		}
		if (@file_put_contents($output_path.DIRECTORY_SEPARATOR.$f, $buff)) {
			$r['file'] = $f;
			$r['progress_mess'] = "<p>write $output_path".DIRECTORY_SEPARATOR."<a href='$output_url$f'>$f</a> </p>";
			$r['basename'] = basename($f);
		} else {
			$r['file'] = "error-".$f;
			$r['skip_page'] = "<p><a href='{$ut->link($id)}'>error($id) : {$params['page']['title']}</a></p>";
		}
	} else {
		$params['data_url'] = $data_url;
		$params['circle']['url'] = $circle_url;
		$config['site_url'] = $site_url;
		$params['circle']['join_flag'] = $join_flag;
		$_SESSION['login_id'] = $login_id_back;
		$params['breadcrumb'] = $breadcrumb;

		$r['file'] = "skip($id)-".$f;
		if ($params['page']['mode']==0) {
			$r['skip_page'] = "<p><a href='{$ut->link($id)}'>draft($id) : {$params['page']['title']}</a></p>";
		} else {
			$r['skip_page'] = "<p><a href='{$ut->link($id)}'>skip($id) : {$params['page']['title']}</a></p>";
		}
	}
	unset($params['page']);
	$params['manager'] = 'staticout';

}

function staticout_get_filename($id)
{
	global $config,$params;
	$f = $config['permalink'];
	if (isset($params['circle']['meta']['f_alias'][$id])) {
		$f = $params['circle']['meta']['f_alias'][$id];
	} else {
		$f = str_replace('{page}', $id, $f);
	}
	$path_parts = pathinfo($f);
	if (!empty($params['staticout_force_ext'])) {
		if (empty($path_parts['extension']) || ($path_parts['extension'] != 'html' && $path_parts['extension'] != 'htm')) {
			$f = $path_parts['filename'].'.html';
		}
	}
	if ($id == $params['circle']['meta']['top_page']) {
		$f = 'index.html';
	}
	return $f;
}

function staticout_before_hook()
{
	global $config,$params,$html;
	$html['head']['generator'] = "<meta name='generator' content='onethird cms' />";
	if (!empty($params['staticout_before_hook']) && function_exists($params['staticout_before_hook'])) {
		$params['staticout_before_hook']();
	}
}

function staticout_after_hook(&$buff, $path)
{

	if (isset($params['staticout_after_hook'])) {
		return $params['staticout_after_hook']($buff, $path);
	}

	$buff = preg_replace_callback(
		"/(img.php|timg.php)\?p=([0-9A-Za-z.]+)\&a?m?p?;?i=([_0-9A-Za-z]+)\.(jpg|gif|png)/u"
		, "_staticout_after_hook"
		, $buff
	);

}

function _staticout_after_hook($matches)
{
	global $staticout_base_path, $config, $p_circle, $params;
	if (count($matches) == 5) {
		$files = substr($config['files_url'],strlen($config['site_url']));
		if ($matches[1] == 'img.php') {
			return $staticout_base_path.$files."img/".$matches[2]."/".$matches[3].".".$matches[4];
		}
		if ($matches[1] == 'timg.php') {
			return $staticout_base_path.$matches[2]."/".$matches[3].".".$matches[4];
		}
	}
	return $matches[0];
}

function staticout_remove_path($v)
{
	global $config,$params,$staticout_base_path;

	if (isset($params['staticout_remove_path'])) {
		return $params['staticout_remove_path']($v);
	}

	$v = str_replace($config['site_url'], $staticout_base_path, $v); 
	return $v;
}

function my_ut_link(&$u)
{
	global $params,$config,$output_url;
	$x = parse_url($u);
	$u = '';
	if (!empty($x['scheme'])) {
		$u .= "{$x['scheme']}://";
	}
	if (!empty($x['host'])) {
		$u .= "{$x['host']}";
	}
	if (!empty($x['port'])) {
		$u .= ":{$x['port']}/";
	} else {
		if ($u) {
			$u .= "/";
		}
	}
	if (!empty($x['path'])) {
		if (substr($x['path'],-5) != '.html' && substr($x['path'],-4) != '.htm') {
			$u .= "{$x['path']}.html";
		} else {
			$u .= "{$x['path']}";
		}
	} else {
		$id = $x['path'] = $params['circle']['meta']['top_page'];
	}
	if (!empty($x['query'])) {
		$u .= "?{$x['query']}";
	}
	if (!$u) {
		$u = "$output_url";
	}
	return $u;
}

?>